require 'time'
out = []
for line in ARGF.each_line
  if line =~ /^(201.*\[)/
    time = Time.parse($1).to_i
  end
  if line =~ /checkpoint starting/
    out << [time, "checkpoint starting"]
  elsif line =~ /checkpoint complete/
    out << [time, "checkpoint complete"]
  elsif line =~ /automatic vacuum of table .*pgbench_accounts/
    accounts_vacuum = true
  elsif accounts_vacuum && line =~ /elapsed: ([\d\.]+) s/
    out << [(time - $1.to_f).to_i, "autovacuum starting"]
    out << [time, "autovacuum complete"]
    accounts_vacuum = nil
  end
end

for time, event in out.sort
  puts "#{time} #{event}"
end
