checkpoint = false
autovacuum = false
test_time = nil

puts format("%-6s %8s %8s %8s %8s %8s %8s",
            *%w{time activity tps latency stddev min max})
for line in ARGF
  time = line[/^\d+/].to_i
  if test_time == nil
    test_time = time - 30
  end
  time -= test_time
  case line
  when /checkpoint starting/
    checkpoint = true
  when /checkpoint complete/
    checkpoint = false
  when /autovacuum starting/
    autovacuum = true
  when /autovacuum complete/
    autovacuum = false
  else
    _, cnt, sum, sumsq, min, max = line.split.map(&:to_f)
    activity = [autovacuum ? "av" : nil, checkpoint ? "ch" : nil]
    activity = activity.compact.join("+")
    tps = cnt/30.0
    lat = sum/cnt/1000
    stddev = (sumsq/cnt - (sum**2)/cnt/(cnt-1)) ** 0.5 / 1000
    puts format("%-6d %8s %8.0f %6.0fms %6.0fms %6.0fms %6.0fms",
               time, activity, tps, lat, stddev, min/1000, max/1000)
  end
end
